﻿using System;

namespace HeuristicLab.Hive.Contracts {
  public class Disposable<T> : IDisposable {
    private T obj;
    public T Obj {
      get { return obj; }
    }

    public Disposable(T obj) {
      this.obj = obj;
    }

    public void Dispose() {
      if (OnDisposing != null)
        OnDisposing(this, new EventArgs());
    }

    public event EventHandler OnDisposing;
  }
}
