﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.PluginInfrastructure;
using HeuristicLab.Hive.Server;
using HeuristicLab.Hive.Server.DataAccess;
using System.Windows.Forms;

namespace HeuristicLab.Hive.Server.Core {
  [Application("Create Hive Database", "Creates new empty Hive Database.", true)]
  class CreateHiveDatabaseApplication : ApplicationBase {

    public override void Run() {
      IContextFactory contextFactory = ServiceLocator.GetContextFactory();
      using (contextFactory.GetContext(false)) {
        if (contextFactory.CurrentContext.DatabaseExists())
          contextFactory.CurrentContext.DeleteDatabase();
        contextFactory.CurrentContext.CreateDatabase();
        MessageBox.Show("Creating Database finished.");
      }
    }
  }
}
